# Run the n-body code pm8.f
# compile option: efc -zero -g (-O3) -o pm8 pm8.f sub.f -L/usr/local/lib -lfftw3f

# Simulation Parameters
ng=512
ngz=$ng
astep=0.1
size=512
seed=7
nspace=2
amax=24
zi=23
omep=0.27
omepb=0.0463
omeplam=0.73
tophat=8
bf=1.11111111
hubble=0.71

# Evolve the cdm mass, and galaxy particles
time pm9b<<LL
$nspace $omep $omepb $omeplam $tophat
$ng $ngz $nspace $size $amax $astep
1 0 $hubble $tophat $bf $seed
cdm
LL
