c234567
      subroutine wdata2disk(ng,ngz,nspace,iseed,size,omep,omeplam,
     &     amax,astep,
     &     pconv,vconv,a,redshift,x,y,z,vx,vy,vz,indx,np,
     &     myrank,nrank,nred10)
      INCLUDE "fftw_f77.i"
      INCLUDE "mpif.h"
      integer ng,ngz,nspace,iseed,np
      real size,omep,amax,astep,pconv,vconv,a,redshift,omeplam
      real x(*),y(*),z(*),vx(*),vy(*),vz(*)
      integer indx(*)
      character*1 proc1,proc2,proc3
      character*3 number
      integer n,ierror,nred10
	  number = char(48+nred10/100)//char(48+mod(nred10,100)/10)//
     &         char(48+mod(nred10,10))
      proc1 = char(48+myrank/100)
      proc2 = char(48+mod(myrank/10,10))
      proc3 = char(48+mod(myrank,10))
      do j = 0, nrank-1
         if(j.eq.myrank) then
            open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
     &                form='unformatted')
            if(myrank.eq.0)print *,' writing data at a=',a
            write(21)ng,ngz,nspace,iseed,np
            write(21)size,omep,omeplam,amax,astep,pconv,vconv
            write(21)a,redshift
            write(21)(indx(i),i=1,np)
            close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      do j = 0, nrank-1
         if(j.eq.myrank) then
            open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
     &                form='unformatted',access='append')
            write(21)(x(i),i=1,np)
            close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      do j = 0, nrank-1
         if(j.eq.myrank) then
            open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
     &                form='unformatted',access='append')
            write(21)(y(i),i=1,np)
            close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo

      do j = 0, nrank-1
         if(j.eq.myrank) then
            open(21,file='p1024.z'//number//'_'//proc1//proc2//proc3,
     &                form='unformatted',access='append')
            write(21)(z(i),i=1,np)
            close(21)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      do j = 0, nrank-1
         if(j.eq.myrank) then
            open(23,file='v1024.z'//number//'_'//proc1//proc2//proc3,
     &                form='unformatted')
            write(23)ng,ngz,nspace,iseed,np
            write(23)size,omep,omeplam,amax,astep,pconv,vconv
            write(23)a,redshift
            write(23)(vx(i),i=1,np)
            close(23)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      do j = 0, nrank-1
         if(j.eq.myrank) then
            open(23,file='v1024.z'//number//'_'//proc1//proc2//proc3,
     &                form='unformatted',access='append')
            write(23)(vy(i),i=1,np)
            close(23)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      do j = 0, nrank-1
         if(j.eq.myrank) then
            open(23,file='v1024.z'//number//'_'//proc1//proc2//proc3,
     &                form='unformatted',access='append')
            write(23)(vz(i),i=1,np)
            close(23)
         endif
         call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      enddo
      call MPI_BARRIER(MPI_COMM_WORLD,ierror)
      if(myrank.eq.0)print *,' wrote data at a=',a
      return
      end

      
