#include<stdio.h>
#include<mpi.h>
#define pi 3.1415926535
fda4gf_c(float *x,float *y,float *z,float *vx,float *vy,float *vz,
		int np,float *den,float *gridfx,float *gridfy,float *gridfz,
		int nx,int ny,int nz,int local_nz,
		float a,float astep,float amax,float omei,float omep,float omeplam,
		float *pfact,int *tabp0,int *tabp1,int *tabm1,int *zabp0,
		int *zabp1,int *zabm1,int local_nz_start,int myrank,int nrank){
	float start_z
	float ainv,app,apsq,afact,bfact,fact1,fact2;
	float ffact1,ffact2;
	float xp,yp,zp,xmin,ymin,zmin,xd1,yd1,zd1;
	float wx1,wy1,wz1,wx2,wy2,wz2,wx3,wy3,wz3;
	float wt1,wt2,wt3,wt4,wt5,wt6,wt7,wt8,wt9,wt10;
    float wt11,wt12,wt13,wt14,wt15,wt16,wt17,wt18,wt19,wt20;
    float wt21,wt22,wt23,wt24,wt25,wt26,wt27;
    float fx1,fx2,fx3,fx4,fx5,fx6,fx7,fx8,fx9,fx10;
    float fx11,fx12,fx13,fx14,fx15,fx16,fx17,fx18,fx19,fx20;
    float fx21,fx22,fx23,fx24,fx25,fx26,fx27;
    float fy1,fy2,fy3,fy4,fy5,fy6,fy7,fy8,fy9,fy10;
    float fy11,fy12,fy13,fy14,fy15,fy16,fy17,fy18,fy19,fy20;
    float fy21,fy22,fy23,fy24,fy25,fy26,fy27;
    float fz1,fz2,fz3,fz4,fz5,fz6,fz7,fz8,fz9,fz10;
    float fz11,fz12,fz13,fz14,fz15,fz16,fz17,fz18,fz19,fz20;
    float fz21,fz22,fz23,fz24,fz25,fz26,fz27;
	int nearx,neary,nearz,xsign,ysign,zsign;
	int i1,j1,k1,i2,j2,k2,i3,j3,k3;
	int i,ng,j,k;
	int i1m1,i1m2,i1p1,i1p2,i2m1,i2m2,i2p1,i2p2,i3m1,i3m2,i3p1;
	int i3p2,j1m1,j1m2,j1p1,j1p2,j2m1,j2m2,j2p1,j2p2,j3m1,j3m2;
	int j3p1,j3p2,k1m1,k1m2,k1p1,k1p2,k2m1,k2m2,k2p1,k2p2,k3m1;
	int k3m2,k3p1,k3p2;
	int im1,im2,ip1,ip2,jm1,jm2,jp1,jp2,km1,km2,kp1,kp2;
	int nz_per,dest,src,sendsize,recvsize,stag,rtag;
	MPI_Status status;
	int ierror;
	float rng,rngz;
	nz_per = local_nz + 7;
	sendsize = 2*(nx/2+1)*ny*2;
	recvsize = sendsize;
	dest = (myrank+1+nrank)%nrank;
	src = (myrank-1+nrank)%nrank;
	stag = 1;
	rtag = 1;
	MPI_Sendrecv((den+(local_nz-2)*2(nx/2+1)*ny),sendsize,MPI_FLOAT,dest,
			stag,(den+(nz_per-2)*2(nx/2+1)*ny),recvsize,MPI_FLOAT,src,
			rtag,MPI_COMM_WORLD,&status);
	sendsize = 2*(Nx/2+1)*Ny*2;
	recvsize = sendsize;
	dest = (myrank-1+nrank)%nrank;
	src = (myrank+1+nrank)%nrank;
	stag = 2;
	rtag = 2;
	MPI_Sendrecv(den,sendsize,MPI_FLOAT,dest,stag,(den+local_nz*2(nx/2+1)*ny),
			recvsize,MPI_FLOAT,src,rtag,MPI_COMM_WORLD,&status);
	/*
	 * Solve the momentum equation by using Friedman equations
	 */
	ng = nz;
	rngz = rng = (float) ng;
	if( a == 1 ) astep = 0.5* astep;
	ainv = 1./a;
	app = -4.*pi/3.*(ainv*ainv-2*omeplam/omep*a/pow(amax,3));
	apsq = 8.*pi/3.*(ainv+1./omei-1+omeplam/omep*(a^2-1)/pow(amax,3));
	afact = (2.+app*a/apsq)/2.*ainv;
    bfact = pow(ainv,3)/apsq;
	fact1 = (1.-afact*astep)/(1.+afact*astep);
	fact2 = bfact*astep/(1.+afact*astep)*rng;
	if(a == 1.) astep = 2.*astep;
	pfact = rng*astep;
	/* Force at grid points by 2-point FDA */
    ffact1 = (4./3.)/2.;
    ffact2 = (-1./3.)/4.;
	/* Here calculating grid force */
	for(k=1;k<=local_nz;k++){
		km1 = zabm1(k);
		km2 = zabm1(km1);
		kp1 = zabp1(k);
		kp2 = zabp1(kp1);
		for(j=1;j<=ng;j++){
			jm1 = tabm1(j);
			jm2 = tabm1(jm1);
			jp1 = tabp1(j);
			jp2 = tabp1(jp1);
			for(i=1,i<=ng;i++){
				im1 = tabm1(i);
				im2 = tabm1(im1);
				ip1 = tabp1(i);
				ip2 = tabp1(ip1);
				gridfx
			}
		}
	}

c---  Here calculating grid force
      do 152 k=1,Nz_local
      km1 = zabm1(k)
      km2 = zabm1(km1)
      kp1 = zabp1(k)
      kp2 = zabp1(kp1)
      do 152 j=1,ng
      jm1 = tabm1(j)
      jm2 = tabm1(jm1)
      jp1 = tabp1(j)
      jp2 = tabp1(jp1)
      do 152 i=1,ng
      im1 = tabm1(i)
      im2 = tabm1(im1)
      ip1 = tabp1(i)
      ip2 = tabp1(ip1)
      gridfx(i,j,k) = ffact1*(den(im1,j,k)-den(ip1,j,k))
     &            +ffact2*(den(im2,j,k)-den(ip2,j,k))
      gridfy(i,j,k) = ffact1*(den(i,jm1,k)-den(i,jp1,k))
     &            +ffact2*(den(i,jm2,k)-den(i,jp2,k))
      gridfz(i,j,k) = ffact1*(den(i,j,km1)-den(i,j,kp1))
     &            +ffact2*(den(i,j,km2)-den(i,j,kp2))
 152  continue
c***  Gather data of buffer gridf?(*,*,Nz_local+1:Nz_local+7)
      sendsize = 2*(Nx/2+1)*Ny*1
      recvsize = sendsize
      dest = mod(myrank+1+nrank,nrank)
      src = mod(myrank-1+nrank,nrank)
      stag = 1
      rtag = 1
      call MPI_SENDRECV(gridfx(1,1,Nz_local),sendsize,MPI_REAL,dest,
     &        stag,gridfx(1,1,Nz_per),recvsize,MPI_REAL,src,rtag,
     &                 MPI_COMM_WORLD,status,ierror)
      stag = 2
      rtag = 2
      call MPI_SENDRECV(gridfy(1,1,Nz_local),sendsize,MPI_REAL,dest,
     &        stag,gridfy(1,1,Nz_per),recvsize,MPI_REAL,src,rtag,
     &                 MPI_COMM_WORLD,status,ierror)
      stag = 3
      rtag = 3
      call MPI_SENDRECV(gridfz(1,1,Nz_local),sendsize,MPI_REAL,dest,
     &        stag,gridfz(1,1,Nz_per),recvsize,MPI_REAL,src,rtag,
     &                 MPI_COMM_WORLD,status,ierror)
      sendsize = 2*(Nx/2+1)*Ny*2
      recvsize = sendsize
      dest = mod(myrank-1+nrank,nrank)
      src = mod(myrank+1+nrank,nrank)
      stag = 0
      rtag = 0
      call MPI_SENDRECV(gridfx(1,1,1),sendsize,MPI_REAL,dest,stag,
     &          gridfx(1,1,Nz_local+1),recvsize,MPI_REAL,src,rtag,
     &                  MPI_COMM_WORLD,status,ierror)
      stag = 9
      rtag = 9
      call MPI_SENDRECV(gridfy(1,1,1),sendsize,MPI_REAL,dest,stag,
     &          gridfy(1,1,Nz_local+1),recvsize,MPI_REAL,src,rtag,
     &                  MPI_COMM_WORLD,status,ierror)
      stag = 10
      rtag = 10
      call MPI_SENDRECV(gridfz(1,1,1),sendsize,MPI_REAL,dest,stag,
     &          gridfz(1,1,Nz_local+1),recvsize,MPI_REAL,src,rtag,
     &                  MPI_COMM_WORLD,status,ierror)

c***  Cell position run from 0 to n-1 and particles from 0 to n
c---  (xp,yp,zp) = particle position
c---  (ic,jc,kc) = major cell's position the superparticle clould belongs to.
c---  (icc,jcc,kcc) = position of the minor cell
c---  Now find the velocity at a+astep/2
c---  CPU : Scalar (4.62), Vector (1.53,12.2,96) for ng = 32,64,128
      start_z = local_nz_start
      do 160 i=1,np
      xp   = x(i)
      yp   = y(i)
      zp   = z(i)-start_z
      nearx= nint(xp)
      neary= nint(yp)
      nearz= nint(zp)
      xmin = xp-nearx
      ymin = yp-neary
      zmin = zp-nearz
      xsign= sign(1.,xmin)
      ysign= sign(1.,ymin)
      zsign= sign(1.,zmin)
      i1  = mod(nearx+ng,ng)+1
      j1  = mod(neary+ng,ng)+1
      k1  = mod(nearz+Nz_per,Nz_per)+1
      i2  = mod(nearx+ng+xsign,ng)+1
      j2  = mod(neary+ng+ysign,ng)+1
      k2  = mod(nearz+Nz_per+zsign,Nz_per)+1
      i3  = mod(nearx+ng-xsign,ng)+1
      j3  = mod(neary+ng-ysign,ng)+1
      k3  = mod(nearz+Nz_per-zsign,Nz_per)+1

      xd1 = abs(xmin)
      yd1 = abs(ymin)
      zd1 = abs(zmin)
      wx1 = 0.75-xd1**2
      wy1 = 0.75-yd1**2
      wz1 = 0.75-zd1**2
      wx2 = 0.5*(0.5+xd1)**2
      wy2 = 0.5*(0.5+yd1)**2
      wz2 = 0.5*(0.5+zd1)**2
      wx3 = 0.5*(0.5-xd1)**2
      wy3 = 0.5*(0.5-yd1)**2
      wz3 = 0.5*(0.5-zd1)**2
      wt1  = wx1*wy1*wz1
      wt2  = wx2*wy1*wz1
      wt3  = wx3*wy1*wz1
      wt4  = wx1*wy2*wz1
      wt5  = wx2*wy2*wz1
      wt6  = wx3*wy2*wz1
      wt7  = wx1*wy3*wz1
      wt8  = wx2*wy3*wz1
      wt9  = wx3*wy3*wz1
      wt10 = wx1*wy1*wz2
      wt11 = wx2*wy1*wz2
      wt12 = wx3*wy1*wz2
      wt13 = wx1*wy2*wz2
      wt14 = wx2*wy2*wz2
      wt15 = wx3*wy2*wz2
      wt16 = wx1*wy3*wz2
      wt17 = wx2*wy3*wz2
      wt18 = wx3*wy3*wz2
      wt19 = wx1*wy1*wz3
      wt20 = wx2*wy1*wz3
      wt21 = wx3*wy1*wz3
      wt22 = wx1*wy2*wz3
      wt23 = wx2*wy2*wz3
      wt24 = wx3*wy2*wz3
      wt25 = wx1*wy3*wz3
      wt26 = wx2*wy3*wz3
      wt27 = wx3*wy3*wz3

      vx(i)=(wt1 *gridfx(i1,j1,k1)+wt2 *gridfx(i2,j1,k1)+
     &       wt3 *gridfx(i3,j1,k1)+wt4 *gridfx(i1,j2,k1)+
     &       wt5 *gridfx(i2,j2,k1)+wt6 *gridfx(i3,j2,k1)+
     &       wt7 *gridfx(i1,j3,k1)+wt8 *gridfx(i2,j3,k1)+
     &       wt9 *gridfx(i3,j3,k1)+wt10*gridfx(i1,j1,k2)+
     &       wt11*gridfx(i2,j1,k2)+wt12*gridfx(i3,j1,k2)+
     &       wt13*gridfx(i1,j2,k2)+wt14*gridfx(i2,j2,k2)+
     &       wt15*gridfx(i3,j2,k2)+wt16*gridfx(i1,j3,k2)+
     &       wt17*gridfx(i2,j3,k2)+wt18*gridfx(i3,j3,k2)+
     &       wt19*gridfx(i1,j1,k3)+wt20*gridfx(i2,j1,k3)+
     &       wt21*gridfx(i3,j1,k3)+wt22*gridfx(i1,j2,k3)+
     &       wt23*gridfx(i2,j2,k3)+wt24*gridfx(i3,j2,k3)+
     &       wt25*gridfx(i1,j3,k3)+wt26*gridfx(i2,j3,k3)+
     &       wt27*gridfx(i3,j3,k3))*fact2+
     &       fact1*vx(i)

      vy(i)=(wt1 *gridfy(i1,j1,k1)+wt2 *gridfy(i2,j1,k1)+
     &       wt3 *gridfy(i3,j1,k1)+wt4 *gridfy(i1,j2,k1)+
     &       wt5 *gridfy(i2,j2,k1)+wt6 *gridfy(i3,j2,k1)+
     &       wt7 *gridfy(i1,j3,k1)+wt8 *gridfy(i2,j3,k1)+
     &       wt9 *gridfy(i3,j3,k1)+wt10*gridfy(i1,j1,k2)+
     &       wt11*gridfy(i2,j1,k2)+wt12*gridfy(i3,j1,k2)+
     &       wt13*gridfy(i1,j2,k2)+wt14*gridfy(i2,j2,k2)+
     &       wt15*gridfy(i3,j2,k2)+wt16*gridfy(i1,j3,k2)+
     &       wt17*gridfy(i2,j3,k2)+wt18*gridfy(i3,j3,k2)+
     &       wt19*gridfy(i1,j1,k3)+wt20*gridfy(i2,j1,k3)+
     &       wt21*gridfy(i3,j1,k3)+wt22*gridfy(i1,j2,k3)+
     &       wt23*gridfy(i2,j2,k3)+wt24*gridfy(i3,j2,k3)+
     &       wt25*gridfy(i1,j3,k3)+wt26*gridfy(i2,j3,k3)+
     &       wt27*gridfy(i3,j3,k3))*fact2+
     &       fact1*vy(i)

      vz(i)=(wt1 *gridfz(i1,j1,k1)+wt2 *gridfz(i2,j1,k1)+
     &       wt3 *gridfz(i3,j1,k1)+wt4 *gridfz(i1,j2,k1)+
     &       wt5 *gridfz(i2,j2,k1)+wt6 *gridfz(i3,j2,k1)+
     &       wt7 *gridfz(i1,j3,k1)+wt8 *gridfz(i2,j3,k1)+
     &       wt9 *gridfz(i3,j3,k1)+wt10*gridfz(i1,j1,k2)+
     &       wt11*gridfz(i2,j1,k2)+wt12*gridfz(i3,j1,k2)+
     &       wt13*gridfz(i1,j2,k2)+wt14*gridfz(i2,j2,k2)+
     &       wt15*gridfz(i3,j2,k2)+wt16*gridfz(i1,j3,k2)+
     &       wt17*gridfz(i2,j3,k2)+wt18*gridfz(i3,j3,k2)+
     &       wt19*gridfz(i1,j1,k3)+wt20*gridfz(i2,j1,k3)+
     &       wt21*gridfz(i3,j1,k3)+wt22*gridfz(i1,j2,k3)+
     &       wt23*gridfz(i2,j2,k3)+wt24*gridfz(i3,j2,k3)+
     &       wt25*gridfz(i1,j3,k3)+wt26*gridfz(i2,j3,k3)+
     &       wt27*gridfz(i3,j3,k3))*fact2+
     &       fact1*vz(i)

      x(i)=amod(x(i)+vx(i)*pfact+rng,rng)
      y(i)=amod(y(i)+vy(i)*pfact+rng,rng)
      z(i)=amod(z(i)+vz(i)*pfact+rngz,rngz)
  160 continue
c     if(myrank .EQ. 0) then
c        print *,'CPU(force) =', etime(CPU)-stime
c     endif


      return
      end
