/* ⼭  theta, phi   0 ` 90  ̳ ̾ Ѵ. */
/*  ٲܷ α׷߿ min,max   acos(xp/sqrt(xp*xp+yp*yp)) 
 *  ٲѴ. */
#define pi 3.1415926535L
#define X0 0.
#define Y0 0.
#define Z0 0.
#define NPERIODIC 8 /*Number of saving bits is 8*sizeof(int)*8bits */
typedef struct InBox {
    int nx,ny,nz;
} InBox;

#ifdef OLD_OBS_SWAP
#define OBSTEMWRITE(bp,np,myid,nid,obsid) {\
	FILE *wp; int i,j,k;\
	char tempfile[190];\
	for(i=0;i<nid;i++){\
		sprintf(tempfile,"tempobs%.5d-id%.5d.dat",obsid,myid);\
		if(myid==i){\
			wp = fopen(tempfile,"w");\
			fwrite(&np,sizeof(int),1,wp);\
			fwrite(bp,sizeof(slcparticletype),np,wp);\
			fclose(wp);\
		}\
		MPI_Barrier(MPI_COMM_WORLD);\
	}\
	Free(bp);\
}
#define OBSTEMREAD(bp,np,myid,nid,obsid) {\
	FILE *fp; int i,j,k;\
	char tempfile[190];\
	for(i=0;i<nid;i++){\
		sprintf(tempfile,"tempobs%.5d-id%.5d.dat",obsid,myid);\
		if(myid==i){\
			np=0;\
			fp = fopen(tempfile,"r");\
			fread(&np,sizeof(int),1,fp);\
			if(np>0){\
				bp = (slcparticletype *)Malloc(sizeof(slcparticletype)*np,PPTR(bp));\
				fread(bp,sizeof(slcparticletype),np,fp);\
			}\
			fclose(fp);\
		}\
		MPI_Barrier(MPI_COMM_WORLD);\
	}\
}
#else
#define OBSTEMWRITE(bp,np,myid,nid,obsid) {\
	FILE *wp; int i,j,k,mp;\
	char tempfile[190];\
	MPI_Status status;\
	if(myid==0){\
		sprintf(tempfile,"tempobs%.5d.dat",obsid);\
		wp = fopen(tempfile,"w");\
		fwrite(&np,sizeof(int),1,wp);\
		fwrite(bp,sizeof(slcparticletype),np,wp);\
		Free(bp);\
		for(i=1;i<nid;i++){\
			MPI_Recv(&np,1,MPI_INT,i,i,MPI_COMM_WORLD,&status);\
			fwrite(&np,sizeof(int),1,wp);\
			if(np>0) {\
				bp = (slcparticletype *)Malloc(sizeof(slcparticletype)*np,PPTR(bp));\
				MPI_Recv(bp,np*sizeof(slcparticletype),MPI_BYTE,i,i,MPI_COMM_WORLD,&status);\
				fwrite(bp,sizeof(slcparticletype),np,wp);\
			}\
			Free(bp);\
		}\
		fclose(wp);\
	}\
	else {\
		MPI_Send(&np,1,MPI_INT,0,myid,MPI_COMM_WORLD);\
		if(np>0) MPI_Send(bp,np*sizeof(slcparticletype),MPI_BYTE,0,myid,MPI_COMM_WORLD);\
		Free(bp);\
	}\
}
#define OBSTEMREAD(bp,np,myid,nid,obsid) {\
	FILE *fp; int i,j,k,mp;\
	char tempfile[190];\
	MPI_Status status;\
	if(myid==nid-1){\
		sprintf(tempfile,"tempobs%.5d.dat",obsid);\
		fp = fopen(tempfile,"r");\
		for(i=0;i<nid;i++){\
			fread(&np,sizeof(int),1,fp);\
			if(np>0) {\
				bp = (slcparticletype*)Malloc(sizeof(slcparticletype)*np,PPTR(bp));\
				fread(bp,sizeof(slcparticletype),np,fp);\
			}\
			if(i<nid-1){\
				MPI_Send(&np,1,MPI_INT,i,i,MPI_COMM_WORLD);\
				if(np>0) {\
					MPI_Send(bp,np*sizeof(slcparticletype),MPI_BYTE,i,i,MPI_COMM_WORLD);\
					Free(bp);\
				}\
			}\
		}\
		fclose(fp);\
	}\
	else {\
		MPI_Recv(&np,1,MPI_INT,nid-1,myid,MPI_COMM_WORLD,&status);\
		if(np>0){\
			bp = (slcparticletype*)Malloc(sizeof(slcparticletype)*np,PPTR(bp));\
			MPI_Recv(bp,np*sizeof(slcparticletype),MPI_BYTE,nid-1,myid,MPI_COMM_WORLD,&status);\
		}\
	}\
}
#endif
