#include<stdio.h>
#include<math.h>
#include<stddef.h>
#include<stdlib.h>
#include<string.h>

typedef struct lightconetype{
	float x,y,z,vx,vy,vz;
}lightconetype;

lightconetype *lightcone;
float omep,omeplam,hubble,boxsize;
float amax,a,astep,X0,Y0,Z0,rmin2,rmax2;
int nx,ny,nz;

int main(int argc, char **argv){
	int i,j,k;
	int nstep;
	char header[190];
	FILE *fp;


	nstep = atoi(argv[2]);

	for(i=1;i<nstep;i++){
		sprintf(header,"%s.%.5d",argv[1],i);
		fp=fopen(header,"r");
		fread(&nx,sizeof(int),1,fp);
		fread(&ny,sizeof(int),1,fp);
		fread(&nz,sizeof(int),1,fp);
		fread(&omep,sizeof(float),1,fp);
		fread(&omeplam,sizeof(float),1,fp);
		fread(&hubble,sizeof(float),1,fp);
		fread(&boxsize,sizeof(float),1,fp);
		fread(&amax,sizeof(float),1,fp);
		fread(&a,sizeof(float),1,fp);
		fread(&astep,sizeof(float),1,fp);
		fread(&X0,sizeof(float),1,fp);
		fread(&Y0,sizeof(float),1,fp);
		fread(&Z0,sizeof(float),1,fp);
		fread(&rmin2,sizeof(float),1,fp);
		fread(&rmax2,sizeof(float),1,fp);
		printf("L%d : %d %d %d %g %g %g %g\n",i,nx,ny,nz,omep,omeplam,hubble,
				boxsize);
		fclose(fp);
	}

}
